#!/usr/bin/env python

"""
A client for updating the display of the ElecFreaks alphanumeric display brick.

Copyright (C) 2015, 2016 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from serial import Serial
from time import sleep
import sys

port = "/dev/ttyUSB0"
rate = 115200

def openPort():
    global s
    s = Serial(port, rate)
    s.setTimeout(5)
    s.readline()

def closePort():
    global s
    s.close()
    s = None

def writeToPort(data):
    s.write(data)
    s.flush()
    print >>sys.stderr, data.rstrip()

def readFromPort():
    resp = s.readline().rstrip("\r\n")
    if resp == "?":
        resp = s.readline().rstrip("\r\n")
    return resp

def console(prompt=True):
    try:
        while 1:
            if prompt:
                cmd = raw_input("> ")
                if cmd:
                    s.write(cmd + "\n")
                    s.flush()
            print s.readline().rstrip("\r\n")
    except EOFError:
        print "Session closed."

if __name__ == "__main__":
    openPort()

    try:
        console(not "--read-only" in sys.argv)
    finally:
        closePort()

# vim: tabstop=4 expandtab shiftwidth=4
