#ifndef __SHAPES_H__
#define __SHAPES_H__

#define ROW0    0x0001
#define ROW1    0x0002
#define ROW2    0x0004
#define ROW3    0x0008
#define ROW4    0x0010
#define ROW5    0x0020
#define ROW6    0x0040
#define ROW7    0x0080
#define ROW8    0x0100
#define ROW9    0x0200
#define ROW10   0x0400
#define ROW11   0x0800
#define ROW12   0x1000
#define ROW13   0x2000
#define ROW14   0x4000
#define ROW15   0x8000

#define TOP_HORIZONTAL          ROW0
#define UPPER_RIGHT_VERTICAL    ROW1
#define LOWER_RIGHT_VERTICAL    ROW2
#define BOTTOM_HORIZONTAL       ROW3
#define LOWER_LEFT_VERTICAL     ROW4
#define UPPER_LEFT_VERTICAL     ROW5
#define LEFT_MIDDLE_HORIZONTAL  ROW6
#define RIGHT_MIDDLE_HORIZONTAL ROW7
#define UPPER_LEFT_DIAGONAL     ROW8
#define UPPER_CENTRE_VERTICAL   ROW9
#define UPPER_RIGHT_DIAGONAL    ROW10
#define LOWER_RIGHT_DIAGONAL    ROW11
#define LOWER_CENTRE_VERTICAL   ROW12
#define LOWER_LEFT_DIAGONAL     ROW13
#define DECIMAL_POINT           ROW14

#define TOP_EDGE                TOP_HORIZONTAL
#define UPPER_ELEMENTS          (UPPER_LEFT_VERTICAL | UPPER_RIGHT_VERTICAL | UPPER_LEFT_DIAGONAL | UPPER_RIGHT_DIAGONAL | UPPER_CENTRE_VERTICAL)
#define MIDDLE_ELEMENTS         (LEFT_MIDDLE_HORIZONTAL | RIGHT_MIDDLE_HORIZONTAL)
#define LOWER_ELEMENTS          (LOWER_LEFT_VERTICAL | LOWER_RIGHT_VERTICAL | LOWER_LEFT_DIAGONAL | LOWER_RIGHT_DIAGONAL | LOWER_CENTRE_VERTICAL)
#define BOTTOM_EDGE             BOTTOM_HORIZONTAL

#define LEFT_EDGE               (LOWER_LEFT_VERTICAL | UPPER_LEFT_VERTICAL)
#define LEFT_ELEMENTS           (LEFT_MIDDLE_HORIZONTAL | UPPER_LEFT_DIAGONAL | LOWER_LEFT_DIAGONAL)
#define CENTRE_ELEMENTS         (UPPER_CENTRE_VERTICAL | LOWER_CENTRE_VERTICAL)
#define RIGHT_ELEMENTS          (RIGHT_MIDDLE_HORIZONTAL | UPPER_RIGHT_DIAGONAL | LOWER_RIGHT_DIAGONAL)
#define RIGHT_EDGE              (LOWER_RIGHT_VERTICAL | UPPER_RIGHT_VERTICAL)

#define OUTER_FRAME             (TOP_HORIZONTAL | RIGHT_EDGE | BOTTOM_HORIZONTAL | LEFT_EDGE)
#define PLUS                    (LEFT_MIDDLE_HORIZONTAL | RIGHT_MIDDLE_HORIZONTAL | UPPER_CENTRE_VERTICAL | LOWER_CENTRE_VERTICAL)
#define DIAGONALS               (UPPER_LEFT_DIAGONAL | UPPER_RIGHT_DIAGONAL | LOWER_RIGHT_DIAGONAL | LOWER_LEFT_DIAGONAL)
#define INNER_ELEMENTS          (PLUS | DIAGONALS)
#define HORIZONTALS             (TOP_HORIZONTAL | BOTTOM_HORIZONTAL | LEFT_MIDDLE_HORIZONTAL | RIGHT_MIDDLE_HORIZONTAL)

#define UPPER_TRIANGLE          (TOP_HORIZONTAL | UPPER_LEFT_DIAGONAL | UPPER_RIGHT_DIAGONAL)
#define LOWER_TRIANGLE          (BOTTOM_HORIZONTAL | LOWER_LEFT_DIAGONAL | LOWER_RIGHT_DIAGONAL)
#define LEFT_TRIANGLE           (UPPER_LEFT_VERTICAL | LOWER_LEFT_VERTICAL | UPPER_LEFT_DIAGONAL | LOWER_LEFT_DIAGONAL)
#define UPPER_LEFT_TRIANGLE     (UPPER_LEFT_VERTICAL | UPPER_LEFT_DIAGONAL | LEFT_MIDDLE_HORIZONTAL)
#define LOWER_LEFT_TRIANGLE     (LOWER_LEFT_VERTICAL | LOWER_LEFT_DIAGONAL | LEFT_MIDDLE_HORIZONTAL)
#define RIGHT_TRIANGLE          (UPPER_RIGHT_VERTICAL | LOWER_RIGHT_VERTICAL | UPPER_RIGHT_DIAGONAL | LOWER_RIGHT_DIAGONAL)
#define UPPER_RIGHT_TRIANGLE    (UPPER_RIGHT_VERTICAL | UPPER_RIGHT_DIAGONAL | RIGHT_MIDDLE_HORIZONTAL)
#define LOWER_RIGHT_TRIANGLE    (LOWER_RIGHT_VERTICAL | LOWER_RIGHT_DIAGONAL | RIGHT_MIDDLE_HORIZONTAL)

#endif /* __SHAPES_H__ */
